#!/usr/bin/env python
# -*- coding: utf-8 -*-
import cv2
import numpy as np

path = "/home/kristoffer/catkin_ws/src/Thesis/pipe_images/"
filename = "thermal.png"
impath = path+filename
thermal_img = cv2.imread(impath,0)
thermal_img = cv2.resize(thermal_img,(1366,768))
cv2.imshow('bluuh',thermal_img)
cv2.waitKey(0)&0xFF
cv2.destroyAllWindows()

delta = 200-20 # change in temperature for image
scale = float(delta)/float(255)
twenties = np.ones((768,1366))*20
imgfloat = thermal_img.astype(np.float32)
imgfloat = imgfloat * scale
imgint = imgfloat.astype(np.uint8)
imgint = imgint+twenties
imgint = imgint.astype(np.uint8) #compansated thermal image celsius
print imgint
cv2.imshow('bluuh',imgint)
cv2.waitKey(0)&0xFF
cv2.destroyAllWindows()
crop_img = imgint[300:530,400:600]
pixelsum = 0
maxvalue = 0
row = 0
for array in crop_img:
    row +=1
    col = 0
    for pixel in array:
        pixelsum += pixel
        col +=1
        if pixel > maxvalue:
            maxvalue = pixel
            maxrow = row
            maxcol = col
        
height, width = crop_img.shape[:2]
pixels = width*height
print maxvalue, "at location", maxrow ,"x",maxcol
print pixels
print pixelsum
avg_temp = pixelsum/pixels
print avg_temp
cv2.imshow('cropped',crop_img)
cv2.waitKey(0)&0xFF
cv2.destroyAllWindows()

bgr_img = cv2.cvtColor(thermal_img, cv2.COLOR_GRAY2BGR)
cv2.rectangle(bgr_img,(400,300),(600,530),(0,0,255),3)
cv2.rectangle(bgr_img,(400+maxcol-5,300+maxrow-5),(405+maxcol,305+maxrow),(255,0,0),3)

font = cv2.FONT_HERSHEY_SIMPLEX
u1 = 330
v1 = 610
string = str(avg_temp)
string2 = str(maxvalue)
cv2.putText(bgr_img,"Avrage temperature: "+string+" C", (100,100), font, 1, (0,0,255))
cv2.putText(bgr_img,"Max temperature: "+string2+" C", (100,150), font, 1, (255,0,0))


cv2.imshow('with rectangle',bgr_img)
cv2.waitKey(0)&0xFF
cv2.destroyAllWindows()
