#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Use this program to initialize the camera_service_node, 
1. For a client, a node does not need to be initialized
2. Setup to wait for the server to be active before calling it
3. Create a handle for calling the service using rospy.ServiceProxy
4. No rospy.spin() for the client
"""
import rospy
import cv2
from cv_bridge import CvBridge
from custom_srvs.srv import image


class Camera_client():
    def __init__(self):
        self.bridge = CvBridge()
        self.path = "/home/kristoffer/catkin_ws/src/Thesis/pipe_images/"
        self.savename = "saved_capture.png"
       
    def main(self):
        print "Waiting for service"
        rospy.wait_for_service("/camera_service")
        try:
            print('Found service')
            camera_client_node = rospy.ServiceProxy("/camera_service",image)
            print("Request sent")
            response = camera_client_node("file")
            print("Server responded")
            print response.is_bigendian
            print response.height
            print response.width
            
            img = self.bridge.imgmsg_to_cv2(response,desired_encoding="passthrough")
            cv2.imshow("service image",img)
            cv2.waitKey()
            cv2.destroyAllWindows()
            print"does stuff!"
            return response
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
                    
if __name__ == '__main__':
    try:
        camera_client = Camera_client()
        camera_client.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass

            
