#!/usr/bin/env python
# -*- coding: utf-8 -*-

import rospy
import cv2
from cv_bridge import CvBridge
from custom_srvs.srv import image, imageResponse

class Camera_service():
     
    def callback(self, request): # request is just a string from client to initialize service
        while not rospy.is_shutdown():
            if request.camera == "cam":
                print "requested camera"
                camera_tag = 0 # ls -ltrh /dev/video* (Find Cam in terminal)
                cap = cv2.VideoCapture(camera_tag)

                if not cap.isOpened():
                    print('Camera not opened!')
                rval, frame = cap.read()
                if rval:
                    rval, frame = cap.read()
                    print frame
                    img = self.bridge.cv2_to_imgmsg(frame, "bgr8")
                    print("Sending image...")
                    response = imageResponse(img.width,img.height,img.is_bigendian,img.encoding,img.data)
                    print('Image sent')
            elif request.camera == "file":
                print "requested image from file"
                camera_tag = str(self.path+self.filename)
                print camera_tag
                imgur = cv2.imread(camera_tag,1)
                img = self.bridge.cv2_to_imgmsg(imgur,"bgr8")
                print('Sending image...')
                response = imageResponse(img.width,img.height,img.is_bigendian,img.encoding,img.data)
                print ('Image sent')
            else:
                print "Request error"
            return response
    
    def main(self):
        print('inside main camera_service')
        self.path = "/home/kristoffer/catkin_ws/src/Thesis/pipe_images/"
#        self.filename = "Weld_station_coord_two_grooves_5_5.png" # ok
#        self.filename = "Weld_station_coord_deeper.png" # ok
#        self.filename = "Weld_station_coord_two_grooves_4_5.png" # not
        self.filename = "Weld_station_coord.png" # ok
#        self.filename = "Weld_station_coord_4_35.png" # not
        self.bridge = CvBridge()        
        
        rospy.init_node('camera_service_node', anonymous=True)
        self.srv = rospy.Service("/camera_service",image,self.callback)        
        rospy.loginfo('Service is running')        
        rospy.spin()

if __name__ == '__main__':
    try:
        camera_service = Camera_service()
        camera_service.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass

            
