#!/usr/bin/env python
# -*- coding: utf-8 -*-

import rospy
import cv2
import numpy as np
import math
from cv_bridge import CvBridge
from custom_srvs.srv import image, imageResponse
from custom_srvs.srv import two_int, two_intResponse

class Crop_image_service():
     
    def __init__(self):
        self.bridge = CvBridge()

    def neck(self,image,minValue,maxValue):
        print('Inside Neck detector')
        # Copy canny image to overlay colored lines     
        copy_canny = cv2.cvtColor(image,cv2.COLOR_GRAY2BGR)
        # Detect lines
        lines = cv2.HoughLinesP(image,1,1*np.pi/180,1,None,50,10)
        x1_list = []
        y1_list = []
        x2_list = []
        y2_list = []
        u, v = image.shape[::-1]
        if lines is not None:
            for i in range(0,len(lines)):
                l = lines[i][0]
                print(l)
                delta_u = float(np.abs(l[2]-l[0]))
                delta_v = float(np.abs(l[3]-l[1]))
                radangle = math.atan2(delta_v,delta_u)
                print radangle
                degangle = radangle*180/np.pi
                print degangle
                if np.abs(degangle) < 35 and np.abs(degangle) > 17:
                    # Draw lines
                    print('approved')
                    print(l)
                    print(degangle,'deg')
    
                    x1_list.append(l[0])
                    y1_list.append(l[1])
                    x2_list.append(l[2])
                    y2_list.append(l[3])
                    self.d_u = 2*(np.abs(l[0]-l[2]))
                    self.d_v = 2*(np.abs(l[1]-l[3]))
                    if l[1]<v/2 and l[3]<v/2:
                        cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(0,0,255),3)
                        cv2.line(copy_canny,(l[0]-self.d_u,l[1]-self.d_v),(l[2],l[3]),(255,0,0),2)
                        self.X2 = l[2]
                        self.Y2 = l[3]
                    else:
                        cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(0,0,255),3)
                        cv2.line(copy_canny,(l[0]-self.d_u,l[1]+self.d_v),(l[2],l[3]),(255,0,0),2)
                        pass
                else:
                    print('neck pass')
                    pass
    
    def minimum(self, aList):
        minPos = aList.index(min(aList))
        maxPos = aList.index(max(aList)) 
        return minPos,maxPos
    
    print('neck lines:')
    print('-_-_-_-_-_-_-_-_'*3)
    def tool_joint_top(self, image):
        # Copy canny image to overlay colored lines 
        copy_canny = cv2.cvtColor(image,cv2.COLOR_GRAY2BGR)
        print('Inside Tool Joint detector')
        # Detect lines
        lines = cv2.HoughLinesP(image,1,1*np.pi/180,100,None,80,40)
        x1_list = []
        y1_list = []
        x2_list = []
        y2_list = []
        u, v = image.shape[::-1]
        if lines is not None:
            for i in range(0,len(lines)):
                l = lines[i][0]
                degangle = np.arctan([np.abs(l[3]-l[1]),np.abs(l[2]-l[0])])*180/np.pi
                if np.abs(degangle[1])<0.5:
                    print('pass')
                    pass
                else:# Draw lines
                    print('x1',l[0],'y1',l[1],'x2',l[2],'y2',l[3])
                    print (degangle[0], degangle[1])
                    x1_list.append(l[0])
                    y1_list.append(l[1])
                    x2_list.append(l[2])
                    y2_list.append(l[3])
            minPos,maxPos = self.minimum(y1_list)
            print('Minimum element location',minPos)
            self.minValue = y1_list[minPos]
            print('minValue',self.minValue)
            self.maxValue = y1_list[maxPos]
            print('maxValue',self.maxValue)
    
            cv2.line(copy_canny,(0,y1_list[minPos]),(u,y2_list[minPos]),(0,255,0),1)
            self.resize_copy_canny = cv2.resize(copy_canny,(1366,768))
            print("end of tool joint top")
    
    
    def ignorator(self,image):
        print ("Inside ignorator")
        print(type(image))
        self.tool_joint_top(image)
        print("Going for neck!")
        self.neck(image,self.minValue,self.maxValue)
        print(self.d_u,self.d_v,self.X2,self.Y2)
        self.d_v = float(self.d_v)
        self.d_u = float(self.d_u)
        a = (((self.d_v/self.d_u)*self.X2)-self.Y2)
        b = float(self.d_v/self.d_u)
        print('a',a,'b',b)
        self.X = (a+self.minValue)/b
        self.ign_u = self.X
        self.tj = self.minValue
        print('X',self.X)

    def callback0(self,request):
        final_canny_avg = self.bridge.imgmsg_to_cv2(self.edge_resp)
        print (type(final_canny_avg))
        self.ignorator(final_canny_avg)    
        crop_img = final_canny_avg[self.tj-150:self.tj+150,int(self.ign_u)-1000:int(self.ign_u)]
        img = self.bridge.cv2_to_imgmsg(crop_img, "mono8")
        print('Sending image...')
        crop_resp = imageResponse(img.width,img.height,img.is_bigendian,img.encoding,img.data)
        print ('Image sent')
        org_res = self.bridge.imgmsg_to_cv2(self.org_resp)
        print("after org res")
        crop_img1 = org_res[self.tj-150:self.tj+150,int(self.ign_u)-1000:int(self.ign_u)]
        self.im = self.bridge.cv2_to_imgmsg(crop_img1,"bgr8")
        print('end of callback0')
        
        return crop_resp
    
    def callback1(self,request):
        print('Sending image...')
        crop_resp_col = imageResponse(self.im.width,self.im.height,self.im.is_bigendian,self.im.encoding,self.im.data)
        print ('Image sent')
        return crop_resp_col
    
    def callback2(self,request):
        print('sending tj and ign_u')
        two_int_resp = two_intResponse(self.tj, self.ign_u)
        print("tj and ign_u sent!")
        return two_int_resp
    
    def main(self):
        print('inside main crop image service')      
        #Insert how to get the info
        print "Waiting for edges image service"
        rospy.wait_for_service("/edges_image_processing_service")
        try:
            print('Found edge service')
            edge_client_node = rospy.ServiceProxy("/edges_image_processing_service",image)
            print("Request sent")
            self.edge_resp = edge_client_node("Run Forrest, Run!")
            print("Server responded")

#            edge_img = self.bridge.imgmsg_to_cv2(self.edge_resp,desired_encoding="passthrough")
#            r_edge_img = cv2.resize(edge_img,(1366,768))
#            cv2.imshow("service image",r_edge_img)
#            cv2.waitKey()
#            cv2.destroyAllWindows()
            print"does stuff!"
#            return self.edge_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
        # TEST Below
        print "Waiting for original image service"
        rospy.wait_for_service("/camera_service")
        try:
            print('Found original service')
            cam_client = rospy.ServiceProxy("/camera_service",image)
            print("Request sent")
            self.org_resp = cam_client("file")
            print("Server responded")

#            org_img = self.bridge.imgmsg_to_cv2(self.org_resp,desired_encoding="passthrough")
#            r_org_img = cv2.resize(org_img,(1366,768))
#            cv2.imshow("original image",r_org_img)
#            cv2.waitKey()
#            cv2.destroyAllWindows()
            print"does stuff!"
#            return self.edge_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
        # TEST Above
        # end new info
        print("create node")
        rospy.init_node('crop_image_node', anonymous=True)
        # Sending result to callback
        self.s = rospy.Service("/crop_image_service",image,self.callback0)
        rospy.loginfo('Crop image Service is running') 
        
        self.sr = rospy.Service("/crop_col_image_service",image,self.callback1)
        rospy.loginfo('Crop color image Service is running') 
        
        self.sr = rospy.Service("/tj_ign_u",two_int,self.callback2)
        rospy.loginfo('Tool joint and ign_u Service is running') 
        
        rospy.spin()

if __name__ == '__main__':
    try:
        crop_image_service = Crop_image_service()
        crop_image_service.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass
