#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
Client
"""

import rospy
import cv2
from cv_bridge import CvBridge
from custom_srvs.srv import image


class Crop_image_client():
    def __init__(self):
        self.bridge = CvBridge()

       
    def main(self):
        print "Waiting for crop service"
        rospy.wait_for_service("/crop_image_service")
        try:
            print('Found service')
            crop_client_node = rospy.ServiceProxy("/crop_image_service",image)
            print("Request sent")
            self.crop_resp = crop_client_node("Run Forrest, Run!")
            print("Server responded")

            img = self.bridge.imgmsg_to_cv2(self.crop_resp,desired_encoding="passthrough")
#            imgr = cv2.resize(img,(1366,768))
            cv2.imshow("service image",img)
            cv2.waitKey()
            cv2.destroyAllWindows()
            print"does stuff!"
#            return self.crop_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
            
            print "Waiting for edged service"
        
        rospy.wait_for_service("/crop_col_image_service")
        try:
            print('Found service')
            crop_col_client_node = rospy.ServiceProxy("/crop_col_image_service",image)
            print("Request sent")
            self.crop_col_resp = crop_col_client_node("Run Forrest, Run!")
            print("Server responded")

            img = self.bridge.imgmsg_to_cv2(self.crop_col_resp,desired_encoding="passthrough")
#            imgt = cv2.resize(img,(1366,768))
            cv2.imshow("service image",img)
            cv2.waitKey()
            cv2.destroyAllWindows()
            print"does stuff!"
#            return self.crop_col_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
                    
if __name__ == '__main__':
    try:
        crop_image_client = Crop_image_client()
        crop_image_client.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass

            
