#!/usr/bin/env python
# -*- coding: utf-8 -*-

import rospy
import cv2
from cv_bridge import CvBridge
from custom_srvs.srv import image


class Edged_image_client():
    def __init__(self):
        self.bridge = CvBridge()

       
    def main(self):
        print "Waiting for edged service"
        rospy.wait_for_service("/edges_image_processing_service")
        try:
            print('Found service')
            edge_client_node = rospy.ServiceProxy("/edges_image_processing_service",image)
            print("Request sent")
            self.edge_resp = edge_client_node("Run Forrest, Run!")
            print("Server responded")

            img = self.bridge.imgmsg_to_cv2(self.edge_resp,desired_encoding="passthrough")
            cv2.imshow("service image",img)
            cv2.waitKey()
            cv2.destroyAllWindows()
            print"does stuff!"
            return self.edge_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
                    
if __name__ == '__main__':
    try:
        edged_image_client = Edged_image_client()
        edged_image_client.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass

            
