#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Service
"""

import rospy
import cv2
import numpy as np
from cv_bridge import CvBridge
from custom_srvs.srv import image, imageResponse

class Edged_image_processing_service():
     
    def callback(self, request): # request is just a string from client to initialize service
        while not rospy.is_shutdown():
            # Do stuff to the info
            img_in = self.imgur
            img = img_in
            # Blurring tuning:
            [sigma,kernel] = [2,3]
            # applying gausian filter to the image
            GaussianBlur = cv2.GaussianBlur(img,(kernel,kernel),sigma)
            # Edge detector tuning
            cnt = 0
            canny_sum = 0
            [start,stop,step] = [80,240,20]
            for i in range(start,stop,step):
                canny1 = i
                print('Loading:',canny1,'out of',stop)
                for j in range(start,stop,step):
                    cnt += 1
                    canny2 = j
                    canny = cv2.Canny(GaussianBlur,canny1,canny2)
                    canny_int32 = np.int32(canny)       
                    canny_sum += canny_int32 
            print('cnt',cnt)
            canny_avg = canny_sum/cnt
            print ('canny avg' , canny_avg)
            canny_avg = canny_avg.astype(np.uint8)
            ret,canny_thr = cv2.threshold(canny_avg,130,255,cv2.THRESH_BINARY)# Thresholding
            print('ret',ret)
            cv2.imwrite(self.path+self.savefile,canny_thr)# Saving generated canny image
            canny_path = self.path+self.savefile
            print(canny_path)
            fin_img = cv2.imread(canny_path,0)

            img = self.bridge.cv2_to_imgmsg(fin_img,"mono8")
            print('Sending image...')
            response = imageResponse(img.width,img.height,img.is_bigendian,img.encoding,img.data)
            print ('Image sent')

            return response
    
    def main(self):
        print('inside main edged image processing service')      
        self.path = '/home/kristoffer/catkin_ws/src/Thesis/pipe_images/'
        self.savefile = 'saved_canny_avg.png'
        self.bridge = CvBridge()
        
        print "Waiting for camera service"
        rospy.wait_for_service("/camera_service")
        try:
            info = rospy.ServiceProxy("/camera_service",image)
            response = info("file")
            print (response.encoding)
            self.imgur = self.bridge.imgmsg_to_cv2(response,desired_encoding="passthrough")
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
        
        rospy.init_node('edged_image_processing_node', anonymous=True)
        # Sending result to callback
        self.srv = rospy.Service("/edges_image_processing_service",image,self.callback)
        rospy.loginfo('Edges Service is running')        
        rospy.spin()
        
if __name__ == '__main__':
    try:
        edged_image_processing_service = Edged_image_processing_service()
        edged_image_processing_service.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass
