#!/usr/bin/env python
# -*- coding: utf-8 -*-


import rospy
import cv2
import numpy as np
from os import listdir
from cv_bridge import CvBridge
from custom_srvs.srv import image, imageResponse
from custom_srvs.srv import two_int
from custom_srvs.srv import img_coord, img_coordResponse

class Feature_detector_service():
     
    def __init__(self):
        print("creating node")
        rospy.init_node('feature_detector_node', anonymous=True)
        self.bridge = CvBridge()
        self.path = '/home/kristoffer/catkin_ws/src/Thesis/pipe_images/'
        self.savefile = 'saved_canny_avg.png'
    def loadImages(self,path):
        # returns an array of images
        self.imagesList = listdir(path)
        self.loadedImages = []
        for item in self.imagesList:
            item = path+item
            img = cv2.imread(item,0)
            self.loadedImages.append(img)
    
    # Detecting the start of weld
    def detectorstart(self,crop_img, crop_img1, imgs, imge, V0, U1, ign_u, tj, color):
        # Import image to search in
        print('Searching in crop_img: ')
        img_gray = crop_img
        cnt = 0
        
        for img in imgs:
            X_0 = img
            cnt +=1
            print('DETECT START:',cnt)        
        
            X_0_Blur = cv2.GaussianBlur(X_0,(1,1),2)
            # applying canny edge detection to the blured image
            canny2 = cv2.Canny(X_0_Blur,100,200)        
            X_0 = canny2
            # Get the size of image
            w, h = X_0.shape[::-1]
            w1, h1 = img_gray.shape[::-1]
            threshold = np.linspace(0.7,0.4,num=20)
            res = cv2.matchTemplate(crop_img,X_0,cv2.TM_CCOEFF_NORMED)
            
            for element in threshold:
                location = np.where(res>= element)
                # Note the if statment ignoring false points, limits depend on image
                t,p_u,p_v = [0,0,0]
                for p in zip(*location[::-1]):
                    if p[1]<V0+20 and p[1]>V0-20: # choses which points to ignore
                        pass# ignore
                    else:
                        print('Feature detected at pixel coordinates: ')
                        print('u = ',p[0])
                        print('v = ',p[1])
                        t += 1
                        p_u += p[0]
                        p_v += p[1]
                        # While loop stopper
                key = cv2.waitKey(1)
                if key == 27:
                    print('while loop engaged')
                    cv2.destroyAllWindows()
                if t == 0:
                    Found = False
                    pass
                else:
                    print('Detected at:',element)
                    U_s = int(p_u/t)
                    V_s = int(p_v/t)
                            
                    [U_e,V_e,we,he]=self.detectorend(crop_img,crop_img1,imge,(0,0,255),U_s,V_s)
                    if U_e == 1 and V_e == 1:
                        Found = False
                        print('Not found')
                        break
                    else:
                        Found = True
                        cv2.rectangle(crop_img1,(U_s,V_s),(U_s+w,V_s+h),(color),3)
                        self.height.append([h,he])
                        self.width.append([w,we])
                        break
                if Found == True:
                    print('t',t)
                    break
            if Found == True: # stopper å leite gjennom flere bilder
                break
        try:
            return U_s,V_s,U_e,V_e,self.width,self.height,Found
        except:
            print('except start')
            a,b,c,d = [1,1,1,1]
            return a,b,c,d,self.width,self.height,True
    
    # Detecting the end of weld
    def detectorend(self,crop_img,crop_img1,imge,color,u,v):
        # Import image to search in
        print('Searching in: crop_img')
        img_gray = crop_img
        # Processing detection image
        cnt = 0
        for img in imge:
            cnt +=1
            print('DETECT END:',cnt)
            X_0 = img
            X_0_Blur = cv2.GaussianBlur(X_0,(1,1),2)
            X_0 = cv2.Canny(X_0_Blur,100,200)        
            w, h = X_0.shape[::-1] # Get the size of image
            w1, h1 = img_gray.shape[::-1]
            threshold = np.linspace(0.7,0.3,num=20)
            res = cv2.matchTemplate(crop_img,X_0,cv2.TM_CCOEFF_NORMED)
            for element in threshold:
                location = np.where(res>= element)
                t,p_u,p_v = [0,0,0]
                for p in zip(*location[::-1]):
                    if p[1] > v+5 or p[1]<v-5 or u-p[0]<20: # choses which points to ignore
                        pass
                    else:
                        print('Feature detected at pixel coordinates: ')
                        print('u = ',p[0])
                        print('v = ',p[1])
                        t = t+1
                        p_u = p_u + p[0]
                        p_v = p_v + p[1]
                key = cv2.waitKey(1)
                if key == 27:
                    print('while loop engaged')
#                    cv2.destroyAllWindows()
                if t == 0:
                    pass
                else:
                    U_e = int(p_u/t)
                    V_e = int(p_v/t)
                    cv2.rectangle(crop_img1,(U_e,V_e),(U_e+w,V_e+h),(color),3)
#                    cv2.imshow('detected', crop_img1)
                    self.img_res = crop_img1
                    break
            if t != 0:
                break
        try:
            return U_e,V_e,w,h
        except:
            print('except')
            a,b,c,d = [1,1,1,1]
            return a,b,c,d
    
    def rename(self,U_start1,V_start1,U_stop1,V_stop1,U_start2,V_start2,U_stop2,V_stop2,w,h):
        if V_start1 < V_start2:
            # first detected start is lower
            x1,y1,x2,y2 = [U_start1,V_start1,U_stop1,V_stop1]
            U_start1,V_start1,U_stop1,V_stop1 = [U_start2,V_start2,U_stop2,V_stop2]
            U_start2,V_start2,U_stop2,V_stop2 = [x1,y1,x2,y2]
            U = list([U_start1,U_stop1,U_start2,U_stop2])
            V = list([V_start1,V_stop1,V_start2,V_stop2])
            if V_stop1 == 1 or V_stop2 == 1:
                W = w
                H = h
            else:
                [w0,w1],[w2,w3] = w
                W = list([w2,w3,w0,w1]) 
                [h0,h1],[h2,h3] = h
                H = list([h2,h3,h0,h1])
        else:
            U = list([self.U0,self.U1,self.U2,self.U3])
            V = list([self.V0,self.V1,self.V2,self.V3])
            if V_stop1 == 1 or V_stop2 == 1:
                W = w
                H = h
            else:            
                [w0,w1],[w2,w3] = w
                W = list([w0,w1,w2,w3])
                [h0,h1],[h2,h3] = h
                H = list([h0,h1,h2,h3])
            pass
        return U,V,W,H 
    
    def translator(self,U,V,tj,ign_u):
        if self.Found == True:
#            U = U + self.ign_u-1000
            w = self.ign_u-1000
            U = [int(U[0]+w),int(U[1]+w),int(U[2]+w),int(U[3]+w)]
            print U
            q = self.tj-150
#            V = V + tj-150
            V = [int(V[0]+q),int(V[1]+q),int(V[2]+q),int(V[3]+q)]
            print V
        else:
            
            U2 = int(U[2] + self.ign_u - 1000)
            U3 = int(U[3] + self.ign_u - 1000)
            V2 = V[2] + tj - 150
            V3 = V[3] + tj - 150
            U = [int(U[0]),int(U[1]),U2,U3]
            V = [V[0],V[1],V2,V3]
        return U, V
    

    # Insert code above   
    def callback1(self,request):
        
        start = '/home/kristoffer/catkin_ws/src/wcm/Master/Code/start/'
        self.loadImages(start)
        imgs = self.loadedImages
        end = '/home/kristoffer/catkin_ws/src/wcm/Master/Code/end/'
        self.loadImages(end)
        imge = self.loadedImages
        # end move to detector part         

        self.width = []
        self.height = []
        
        [self.U0,self.V0,self.U1,self.V1,self.w,self.h,self.Found]=self.detectorstart(self.gray_img,self.col_img,imgs,imge,10,1,self.ign_u,self.tj,(0,255,0))
        print('width',self.w,'height',self.h)
        
        print('Detecting second round: ')
        [self.U2,self.V2,self.U3,self.V3,self.w,self.h,self.Found]=self.detectorstart(self.gray_img,self.col_img,imgs,imge,self.V0,self.U1,self.ign_u,self.tj,(0,255,0))
        print('width',type(self.w),'height',self.h)
        
        if np.abs(self.U0-self.U2)<2 and np.abs(self.U1-self.U3)<2:
            self.V_stop1 = 1
        
        U,V,W,H = self.rename(self.U0,self.V0,self.U1,self.V1,self.U2,self.V2,self.U3,self.V3,self.w,self.h)
        print('U',U)
        U,V = self.translator(U,V,self.tj,self.ign_u)
        print('U',U)
        self.U_0,self.U_1,self.U_2,self.U_3 = U[0],U[1],U[2],U[3]
        self.V_0,self.V_1,self.V_2,self.V_3 = V[0],V[1],V[2],V[3]

        print('First weldgun position from: [',U[0],',',V[0],']to: [',U[1],',',V[1],']')
        print('Second weldgun position from: [',U[2],',',V[2],']to: [',U[3],',',V[3],']')
#        cv2.waitKey(0) &0xFF
#        cv2.destroyAllWindows()
        self.im = self.bridge.cv2_to_imgmsg(self.img_res, "bgr8")        
        print('Sending image...')
        crop_resp_col = imageResponse(self.im.width,self.im.height,self.im.is_bigendian,self.im.encoding,self.im.data)
        print ('Image sent')
        return crop_resp_col
    
    
    def callback0(self,request):
        print('Sending coordinates...')
        print self.U_0
        image_coordinates = img_coordResponse(self.U_0,self.U_1,self.U_2,self.U_3,self.V_0,self.V_1,self.V_2,self.V_3)
        print ('Coordinates sent')
        print('end of callback0')
        return image_coordinates    
    def main(self):
        ####################### Calling Crop Gray #############################
        print "Waiting for crop image service"
        rospy.wait_for_service("/crop_image_service")
        try:
            print('Found crop image service')
            edge_client_node = rospy.ServiceProxy("/crop_image_service",image)
            print("Request sent")
            self.gray_resp = edge_client_node("Run Forrest, Run!")
            print("Server responded")
            self.gray_img = self.bridge.imgmsg_to_cv2(self.gray_resp,desired_encoding="passthrough")
#            cv2.imshow("service image",self.gray_img)
#            cv2.waitKey()
#            cv2.destroyAllWindows()
            print"does stuff!"
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
        ####################### Calling Crop Color ############################
        print "Waiting for crop color image service"
        rospy.wait_for_service("/crop_col_image_service")
        try:
            print('Found crop color image service')
            crop_col_client = rospy.ServiceProxy("/crop_col_image_service",image)
            print("Request sent")
            self.col_resp = crop_col_client("file")
            print("Server responded")
            self.col_img = self.bridge.imgmsg_to_cv2(self.col_resp,desired_encoding="passthrough")
#            cv2.imshow("original image",self.col_img)
#            cv2.waitKey()
#            cv2.destroyAllWindows()
            print"does stuff!"
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
            
        ####################### Calling Crop Color ############################        
        print "Waiting tj_ign_u service"
        rospy.wait_for_service("/tj_ign_u")
        try:
            print('Found tj and ign_u service')
            twoint = rospy.ServiceProxy("/tj_ign_u",two_int)
            print("Request sent")
            tj_ign_u_resp = twoint()
            print("Server responded")
            self.tj = tj_ign_u_resp.tj
            print(self.tj)
            self.ign_u = tj_ign_u_resp.ign_u
            print(self.ign_u)
            print"does stuff!"
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
        ####################### Activating service ############################
        # Sending image.srv result from client to service with callback function
        self.s = rospy.Service("/detected_image",image,self.callback1)
        rospy.loginfo('Feature detection Service is running') 
        
        # Sending image.srv result from client to service with callback function
        self.sr = rospy.Service("/image_coord",img_coord,self.callback0)
        rospy.loginfo('Image coordinate service is running') 
        
        rospy.spin()

if __name__ == '__main__':
    try:
        feature_detector_service = Feature_detector_service()
        feature_detector_service.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass
