#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
Client
"""

import rospy
import cv2
from cv_bridge import CvBridge
from custom_srvs.srv import image
from custom_srvs.srv import img_coord


class Detect_image_client():
    def __init__(self):
        self.bridge = CvBridge()

       
    def main(self):
        print "Waiting for detect service"
        rospy.wait_for_service("/detected_image")
        try:
            print('Found service')
            detected_image = rospy.ServiceProxy("/detected_image",image)
            self.detect_resp = detected_image("Run Forrest, Run!")            
            print("Request sent")
            self.detect_resp = detected_image("Run Forrest, Run!")
            print("Server responded")
            img = self.bridge.imgmsg_to_cv2(self.detect_resp,desired_encoding="passthrough")
            cv2.imshow("service image",img)
            cv2.waitKey()
            cv2.destroyAllWindows()
            print"does stuff!"
#            return self.crop_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
            
            print "Waiting for image_coord service"
        rospy.wait_for_service("/image_coord")
        try:
            print('Found service')
            detected_position = rospy.ServiceProxy("/image_coord",img_coord)
            print("Request sent")
            self.pos_resp = detected_position()
            print("Server responded")
            print self.pos_resp
            print"does stuff!"
#            return self.crop_col_resp
        except rospy.ServiceException, e:
            print "Service call failed: %s"%e
#        

        
        
        
if __name__ == '__main__':
    try:
        detect_image_client = Detect_image_client()
        detect_image_client.main()
    except rospy.ROSInterruptException:
        cv2.destroyAllWindows(0)
        pass

            
