#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 30 13:19:55 2019

@author: Kristoffer
"""
from __future__ import division # allows python 2.7 to use true division
import cv2
import numpy as np
from os import listdir
import time
import math
start_time = time.time()

pi = np.pi
# Read image 
path = '/home/kristoffer/catkin_ws/src/Thesis/pipe_images/'
#filename = "Weld_station_coord_4_35.png" #Filename Input OK 2
#filename = "Weld_station_coord.png" #Filename Input OK 3
#filename = "Weld_station_coord_two_grooves_4_5.png" #Filename Input OK 1
filename = "Weld_station_coord_two_grooves_5_5.png" #Filename Input OK 5
#filename = "Weld_station_coord_deeper.png" #Filename Input OK 4
savefile = "savefile.png" #Savename image with edges
saveresult = "dp_texture_result.png"#Savename image detected feature

image = path + filename
img = cv2.imread(image,0) # image is grey scale due to (,0)
img1 = cv2.imread(image,1) # used to overlay result on original image
resize_img = cv2.resize(img,(1920,1080))
resize_img1 = cv2.resize(img1,(1366,768))
cv2.imshow('Original image:',resize_img1)

cv2.waitKey() & 0xFF
cv2.destroyAllWindows()

# Blurring tuning:
[sigma,kernel] = [2,3]
# applying gausian filter to the image
GaussianBlur = cv2.GaussianBlur(img,(kernel,kernel),sigma)
# Edge detector tuning
cnt = 0
canny_sum = 0
[start,stop,step] = [80,240,20]
for i in range(start,stop,step):
    canny1 = i
    print('Loading:',canny1,'out of',stop)
    for j in range(start,stop,step):
        cnt += 1
        canny2 = j
        canny = cv2.Canny(GaussianBlur,canny1,canny2)
        canny_int32 = np.int32(canny)       
        canny_sum += canny_int32 
print('cnt',cnt)
canny_avg = canny_sum/cnt
print ('canny avg' , canny_avg)
canny_avg = canny_avg.astype(np.uint8)
ret,canny_thr = cv2.threshold(canny_avg,150,255,cv2.THRESH_BINARY)# Thresholding
print('ret',ret)
resize_canny_thr = cv2.resize(canny_thr,(1366,768))
cv2.imshow('resized bluh',resize_canny_thr)
cv2.imwrite(path+savefile,canny_thr)# Saving generated canny image
canny_path = path+savefile
print(canny_path)
final_canny_avg = cv2.imread(canny_path,0)
resize_canny_avg = cv2.resize(final_canny_avg,(1366,768))

print('zups')
cv2.imshow('Final Canny avg ',resize_canny_avg)

cv2.waitKey() & 0xFF
cv2.destroyAllWindows()

def neck(image,minValue,maxValue):
    print('Inside Neck detector')
    # Copy canny image to overlay colored lines     
    copy_canny = cv2.cvtColor(image,cv2.COLOR_GRAY2BGR)
    # Detect lines
    lines = cv2.HoughLinesP(image,1,1*np.pi/180,1,None,50,10)
    x1_list = []
    y1_list = []
    x2_list = []
    y2_list = []
    u, v = image.shape[::-1]
    if lines is not None:
        for i in range(0,len(lines)):
            l = lines[i][0]
            print(l)
            delta_u = float(np.abs(l[2]-l[0]))
            delta_v = float(np.abs(l[3]-l[1]))
            radangle = math.atan2(delta_v,delta_u)
            print radangle
            degangle = radangle*180/np.pi
            print degangle
            if np.abs(degangle) < 35 and np.abs(degangle) > 17:
                # Draw lines
                print('approved')
                print(l)
                print(degangle,'deg')

                x1_list.append(l[0])
                y1_list.append(l[1])
                x2_list.append(l[2])
                y2_list.append(l[3])
                d_u = 2*(np.abs(l[0]-l[2]))
                d_v = 2*(np.abs(l[1]-l[3]))
                if l[1]<v/2 and l[3]<v/2:
                    cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(0,0,255),3)
                    cv2.line(copy_canny,(l[0]-d_u,l[1]-d_v),(l[2],l[3]),(255,0,0),2)
                    resize_copy_canny = cv2.resize(copy_canny,(1366,768))
                    X2 = l[2]
                    Y2 = l[3]
                else:
                    cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(0,0,255),3)
                    cv2.line(copy_canny,(l[0]-d_u,l[1]+d_v),(l[2],l[3]),(255,0,0),2)
                    resize_copy_canny = cv2.resize(copy_canny,(1366,768))
                    pass
                cv2.imshow('neck',resize_copy_canny)
            else:
                print('neck pass')
                pass
        return d_u,d_v,X2,Y2

def minimum(aList):
    minPos = aList.index(min(aList))
    maxPos = aList.index(max(aList)) 
    return minPos,maxPos

print('neck lines:')
print('-_-_-_-_-_-_-_-_'*3)
def tool_joint_top(image):
    # Copy canny image to overlay colored lines 
    copy_canny = cv2.cvtColor(image,cv2.COLOR_GRAY2BGR)
    print('Inside Tool Joint detector')
    # Detect lines
    lines = cv2.HoughLinesP(image,1,1*np.pi/180,100,None,80,40)
    x1_list = []
    y1_list = []
    x2_list = []
    y2_list = []
    u, v = image.shape[::-1]
    if lines is not None:
        for i in range(0,len(lines)):
            l = lines[i][0]
            degangle = np.arctan([np.abs(l[3]-l[1]),np.abs(l[2]-l[0])])*180/np.pi
#            print(degangle)
            if np.abs(degangle[1])<0.5:
                print('pass')
                pass
            else:# Draw lines
                print('x1',l[0],'y1',l[1],'x2',l[2],'y2',l[3])
                print (degangle[0], degangle[1])
                x1_list.append(l[0])
                y1_list.append(l[1])
                x2_list.append(l[2])
                y2_list.append(l[3])
        minPos,maxPos = minimum(y1_list)
        print('Minimum element location',minPos)
        minValue = y1_list[minPos]
        print('minValue',minValue)
        maxValue = y1_list[maxPos]
        print('maxValue',maxValue)

        cv2.line(copy_canny,(0,y1_list[minPos]),(u,y2_list[minPos]),(0,255,0),1)
        resize_copy_canny = cv2.resize(copy_canny,(1366,768))
        cv2.imshow('tool_joint',resize_copy_canny)
        return minValue,maxValue

def ignorator(image):
    minValue,maxValue=tool_joint_top(image)
    cv2.waitKey(0) &0xFF
    cv2.destroyAllWindows()
    
    [d_u,d_v,X2,Y2]=neck(image,minValue,maxValue)
    cv2.waitKey(0) &0xFF
    cv2.destroyAllWindows()
    print(d_u,d_v,X2,Y2)
    d_v = float(d_v)
    d_u = float(d_u)
    a = (((d_v/d_u)*X2)-Y2)
    b = float(d_v/d_u)
    print('a',a,'b',b)
    X = (a+minValue)/b
    print('X',X)
    return X,minValue

ign_u,tj = ignorator(final_canny_avg)


crop_img = final_canny_avg[tj-150:tj+150,int(ign_u)-1000:int(ign_u)]
cv2.imshow('cropped',crop_img)
cv2.waitKey(0)&0xFF
cv2.destroyAllWindows()
cv2.imwrite(savefile+path,crop_img)
crop_img1 = img1[tj-150:tj+150,int(ign_u)-1000:int(ign_u)]


def loadImages(path):
    # returns an array of images
    imagesList = listdir(path)
    loadedImages = []
    for image in imagesList:
        image = path+image
        img = cv2.imread(image,0)
        loadedImages.append(img)
    return loadedImages,imagesList

start = '/home/kristoffer/catkin_ws/src/wcm/Master/Code/start/'
imgs, imgsList = loadImages(start)
print(imgsList)
end = '/home/kristoffer/catkin_ws/src/wcm/Master/Code/end/'
imge, imgeList = loadImages(end)
print(imgsList)

width = []
height = []
# Detecting the start of weld
def detectorstart(search, imgs, imge, V0, U1, ign_u, tj, color):
    # Import image to search in
    print('Searching in: ',search)
  
    image = path + search

    img_bgr = cv2.imread(image)
    img_gray = cv2.cvtColor(img_bgr,cv2.COLOR_BGR2GRAY)
###############################################################################    
    cnt = 0
    
    for img in imgs:
        X_0 = img
        cnt +=1
        print type(X_0)
        print('DETECT START:',cnt)        
    
###############################################################################
        X_0_Blur = cv2.GaussianBlur(X_0,(1,1),2)
        # applying canny edge detection to the blured image
        canny2 = cv2.Canny(X_0_Blur,100,200)        
        X_0 = canny2
        # Get the size of image
        w, h = X_0.shape[::-1]
        w1, h1 = img_gray.shape[::-1]
        threshold = np.linspace(0.7,0.4,num=20)
        res = cv2.matchTemplate(crop_img,X_0,cv2.TM_CCOEFF_NORMED)
        
        for element in threshold:
            location = np.where(res>= element)
            # Note the if statment ignoring false points, limits depend on image
            t,p_u,p_v = [0,0,0]
            for p in zip(*location[::-1]):
                if p[1]<V0+20 and p[1]>V0-20: # choses which points to ignore
                    pass# ignore
                else:
                    print('Feature detected at pixel coordinates: ')
                    print('u = ',p[0])
                    print('v = ',p[1])
                    t += 1
                    p_u += p[0]
                    p_v += p[1]
                    # While loop stopper
            key = cv2.waitKey(1)
            if key == 27:
                print('while loop engaged')
                cv2.destroyAllWindows()
            if t == 0:
                Found = False
                pass
            else:
                print('Detected at:',element)
                U_s = int(p_u/t)
                V_s = int(p_v/t)
                        
                [U_e,V_e,we,he]=detectorend(savefile,imge,(0,0,255),U_s,V_s)
                if U_e == 1 and V_e == 1:
                    Found = False
                    print('Not found')
                    break
                else:
                    Found = True
                    cv2.rectangle(crop_img1,(U_s,V_s),(U_s+w,V_s+h),(color),3)
                    cv2.imshow('detected', crop_img1)
                    
                    height.append([h,he])
                    width.append([w,we])
                    break
            if Found == True:
                print('t',t)
                break
        if Found == True: # stopper å leite gjennom flere bilder
            break
    try:
        return U_s,V_s,U_e,V_e,width,height,Found
    except:
        print('except start')
        a,b,c,d = [1,1,1,1]
        return a,b,c,d,width,height,True

# Detecting the end of weld
def detectorend(search,imge,color,u,v):
    # Import image to search in
    print('Searching in: ',search)
    image = path + search

    img_bgr = cv2.imread(image)
    img_gray = cv2.cvtColor(img_bgr,cv2.COLOR_BGR2GRAY)
    # Processing detection image
    cnt = 0
    for img in imge:
        cnt +=1
        print('DETECT END:',cnt)
        X_0 = img
                
        X_0_Blur = cv2.GaussianBlur(X_0,(1,1),2)
        X_0 = cv2.Canny(X_0_Blur,100,200)        
        # Get the size of image
        w, h = X_0.shape[::-1]
        w1, h1 = img_gray.shape[::-1]
        threshold = np.linspace(0.7,0.3,num=20)
        res = cv2.matchTemplate(crop_img,X_0,cv2.TM_CCOEFF_NORMED)
        for element in threshold:
            location = np.where(res>= element)
            t,p_u,p_v = [0,0,0]
            for p in zip(*location[::-1]):
                if p[1] > v+5 or p[1]<v-5 or u-p[0]<20: # choses which points to ignore
                    pass
                else:
#                    print('Image saved')
                    print('Feature detected at pixel coordinates: ')
                    print('u = ',p[0])
                    print('v = ',p[1])
                    t = t+1
                    p_u = p_u + p[0]
                    p_v = p_v + p[1]
            key = cv2.waitKey(1)
            if key == 27:
                print('while loop engaged')
                cv2.destroyAllWindows()
            if t == 0:
    #                print('No features detected')
                pass
            else:
                U_e = int(p_u/t)
                V_e = int(p_v/t)
                cv2.rectangle(crop_img1,(U_e,V_e),(U_e+w,V_e+h),(color),3)
                cv2.imshow('detected', crop_img1)
                break
        if t != 0:
            break
    try:
        return U_e,V_e,w,h
    except:
        print('except')
        a,b,c,d = [1,1,1,1]
        return a,b,c,d

print('-_-_-_-_-_-_-_-_'*3)
print('Weld start and end detector:')
print('-_-_-_-_-_-_-_-_'*3)

print('Detecting first round: ')
[U0,V0,U1,V1,w,h,Found]=detectorstart(savefile,imgs,imge,10,1,ign_u,tj,(0,255,0))
print('width',w,'height',h)

print('Detecting second round: ')
[U2,V2,U3,V3,w,h,Found]=detectorstart(savefile,imgs,imge,V0,U1,ign_u,tj,(0,255,0))
print('width',type(w),'height',h)

if np.abs(U0-U2)<2 and np.abs(U1-U3)<2:
    V_stop1 = 1


def rename(U_start1,V_start1,U_stop1,V_stop1,U_start2,V_start2,U_stop2,V_stop2,w,h):
    if V_start1 < V_start2:
        # first detected start is lower
        x1,y1,x2,y2 = [U_start1,V_start1,U_stop1,V_stop1]
        U_start1,V_start1,U_stop1,V_stop1 = [U_start2,V_start2,U_stop2,V_stop2]
        U_start2,V_start2,U_stop2,V_stop2 = [x1,y1,x2,y2]
        U = list([U_start1,U_stop1,U_start2,U_stop2])
        V = list([V_start1,V_stop1,V_start2,V_stop2])
        if V_stop1 == 1 or V_stop2 == 1:
            W = w
            H = h
        else:
            [w0,w1],[w2,w3] = w
            W = list([w2,w3,w0,w1]) 
            [h0,h1],[h2,h3] = h
            H = list([h2,h3,h0,h1])
    else:
        U = list([U0,U1,U2,U3])
        V = list([V0,V1,V2,V3])
        if V_stop1 == 1 or V_stop2 == 1:
            W = w
            H = h
        else:            
            [w0,w1],[w2,w3] = w
            W = list([w0,w1,w2,w3])
            [h0,h1],[h2,h3] = h
            H = list([h0,h1,h2,h3])
        pass
    return U,V,W,H 

U,V,W,H = rename(U0,V0,U1,V1,U2,V2,U3,V3,w,h)
print('U',U)

def translator(U,V,tj,ign_u):
    if Found == True:
        U = U + ign_u-1000
        U = [int(U[0]),int(U[1]),int(U[2]),int(U[3])]
        V = V + tj-150
    else:
        U2 = int(U[2] + ign_u - 1000)
        U3 = int(U[3] + ign_u - 1000)
        V2 = V[2] + tj - 150
        V3 = V[3] + tj - 150
        U = [int(U[0]),int(U[1]),U2,U3]
        V = [V[0],V[1],V2,V3]
    return U, V
U,V = translator(U,V,tj,ign_u)
print('U',U)
print('First weldgun position from: [',U[0],',',V[0],']to: [',U[1],',',V[1],']')
print('Second weldgun position from: [',U[2],',',V[2],']to: [',U[3],',',V[3],']')
cv2.waitKey(0) &0xFF
cv2.destroyAllWindows()

print('-_-_-_-_-_-_-_-_'*3)
print('Diameter estimation:')
print('-_-_-_-_-_-_-_-_'*3)

def tool_joint(image,U,V,ign_u,W,H):
    # Copy canny image to overlay colored lines 
    copy_canny = cv2.cvtColor(image,cv2.COLOR_GRAY2BGR)
    print('Inside Tool Joint detector')
    # Detect lines
    lines = cv2.HoughLinesP(image,1,1*np.pi/180,30,None,100,20)
    x1_list = []
    y1_list = []
    x2_list = []
    y2_list = []
    if lines is not None:
        for i in range(0,len(lines)):
            l = lines[i][0]
            degangle = np.arctan(np.abs(l[3]-l[1])/np.abs(l[2]-l[0]))*180/np.pi
            if np.abs(degangle)>0.5 or l[1]>V+5 or l[1]<V-50:
                pass
            else:# Draw lines
                print('x1',l[0],'y1',l[1],'x2',l[2],'y2',l[3])
                x1_list.append(l[0])
                y1_list.append(l[1])
                x2_list.append(l[2])
                y2_list.append(l[3])

                cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(255,0,0),3)
                resize_copy_canny = cv2.resize(copy_canny,(1366,768))
                cv2.imshow('tool_joint',resize_copy_canny)
        return x1_list,y1_list,x2_list,y2_list

def groove1(search,U3,U2,V,a,tj,ign_u,W1,W2,H):# Last weld
    # Copy canny image to overlay colored lines 
    copy_canny = cv2.cvtColor(search,cv2.COLOR_GRAY2BGR)
    # Detect lines
    length = (U2-U3)*5/10
    gap = int(length)
    lines = cv2.HoughLinesP(search,1,1*np.pi/180,30,None,length,(gap))
    x1_list = []
    y1_list = []
    x2_list = []
    y2_list = []
    if lines is not None:
        print('tj',tj,'U3',U3,'U2',U2,'W1',W1,'W2',W2,'H',H)
        for i in range(0,len(lines)):
            l = lines[i][0]
            print(l)
            degangle = np.arctan(np.abs(l[3]-l[1])/np.abs(l[2]-l[0]))*180/np.pi
            
            if np.abs(degangle)>0.5 or l[1]<tj or l[1]>tj+150 or l[0]<=U3-4*W1 or l[2]>=U2+4*W2 or l[1]>tj+3*H:#or l[1]<V_stop2-15
                pass
            else:# Draw lines
                print('x1',l[0],'y1',l[1],'x2',l[2],'y2',l[3])
                x1_list.append(l[0])
                y1_list.append(l[1])
                x2_list.append(l[2])
                y2_list.append(l[3])
        print('tj',tj,'U3',U3,'U2',U2,'W1',W1,'W2',W2,'H',H)        
        minPos,maxPos = minimum(y1_list)
        cv2.line(copy_canny,(x1_list[minPos],y1_list[minPos]),(x2_list[minPos],y2_list[minPos]),(255,0,0),3)
        resize_copy_canny = cv2.resize(copy_canny,(1366,768))
        cv2.imshow('groove_1',resize_copy_canny)
        return x1_list,y1_list,x2_list,y2_list

def groove2(search,U,V,g1,ign_u,W1,W2,H):# First weld
    # Copy canny image to overlay colored lines 
    copy_canny = cv2.cvtColor(search,cv2.COLOR_GRAY2BGR)
    # Detect lines
    length = (U[0]-U[1])/4
    gap = 10
    lines = cv2.HoughLinesP(search,1,1*np.pi/180,30,None,length,(gap))
    x1_list = []
    y1_list = []
    x2_list = []
    y2_list = []
    if lines is not None:
        for i in range(0,len(lines)):
            l = lines[i][0]
            degangle = np.arctan(np.abs(l[3]-l[1])/np.abs(l[2]-l[0]))*180/np.pi
            if np.abs(degangle)>0.5 or l[1]<g1+5 or l[1]>g1+200 or l[0]<U[3]-W1 or l[2]>U[2]+W2:
                pass
            else:# Draw lines
                print('x1',l[0],'y1',l[1],'x2',l[2],'y2',l[3])
                x1_list.append(l[0])
                y1_list.append(l[1])
                x2_list.append(l[2])
                y2_list.append(l[3])

                cv2.line(copy_canny,(l[0],l[1]),(l[2],l[3]),(255,0,0),3)
                resize_copy_canny = cv2.resize(copy_canny,(1366,768))
                cv2.imshow('groove_2',resize_copy_canny)
        return x1_list,y1_list,x2_list,y2_list

def transformation(U,V):
    pi = np.pi
    def rotx(theta):
        ct = np.cos(theta);
        st = np.sin(theta);
        R = np.array([[1, 0,  0],
                      [0,ct,-st],
                      [0,st, ct]])
        return R # theta rotation about x-axis
    def rotz(theta):
        ct = np.cos(theta);
        st = np.sin(theta);
        R = np.array([[ct,-st,0],
                      [st, ct,0],
                      [0,  0, 1]])
        return R # theta rotation about z-axis
    def tran(R,v):
        T = np.array([[R[0][0],R[0][1],R[0][2],float(v[0])],
                      [R[1][0],R[1][1],R[1][2],float(v[1])],
                      [R[2][0],R[2][1],R[2][2],float(v[2])],
                      [0,0,0,1]])
        return np.round(T,3)
    
    K = np.array([[3250, 0, 3017/2],
                  [0, 3650, 1704/2],
                  [0, 0, 1]])

    empt = []
    
    z = 0.7 # z is distance between camera and point along optical axis
    p = np.array([[U],
                  [V]])
    tc_co = np.array([[-0.3],
                      [0],
                      [z]])
    s_x = (p[0]-K[0][2])/K[0][0]
    s_y = (p[1]-K[1][2])/K[1][1]
    s = np.append(empt,[s_x,s_y])
    s = np.reshape(s,(2,1))
    s_tilde = np.append(s,1)
    s_tilde = np.reshape(s_tilde,(3,1))
    rc_cp = (s_tilde)*z
    rc_cp_tilde = np.append(rc_cp,1)
    rc_cp_tilde = np.reshape(rc_cp_tilde,(4,1))
    Rx = rotx(pi/2)
    Rz = rotz(-pi/2)
    RT = np.dot(Rx,Rz)
#    RT = Rx@Rz
    T = tran(RT,tc_co)
    T_inv = np.linalg.inv(T)
    ro_op_tilde = np.dot(T_inv,rc_cp_tilde)
    return ro_op_tilde[0],ro_op_tilde[1],ro_op_tilde[2]

# Welding programme
def layer(soft_height,max_weld_height,d):
    if soft_height/max_weld_height<=(1.01):
        string_height = soft_height
        layers = 1
        D = d+2*string_height
        weld_area = (pi/4)*(D**2-d**2)
        print('Need one layer of weld, ',np.round(string_height*1000,3),'mm each layer')
    elif soft_height/max_weld_height>(1.01) and soft_height/max_weld_height<=(2.01):
        string_height = soft_height/2
        layers = 2
        D = d+2*string_height
        weld_area1 = (pi/4)*(D**2-d**2)
        D1 = d+2*2*string_height
        weld_area2 = (pi/4)*(D1**2-D**2)
        weld_area = [weld_area1,weld_area2]
        print('Need two layers of weld, ',np.round(string_height*1000,3),'mm each layer')
    elif soft_height/max_weld_height>(2.01) and soft_height/max_weld_height<=(3.01):
        string_height = soft_height/3
        layers = 3
        D = d+1*2*string_height
        weld_area1 = (pi/4)*(D**2-d**2)
        D1 = d+2*2*string_height
        weld_area2 = (pi/4)*(D1**2-D**2)
        D2 = d+3*2*string_height
        weld_area3 = (pi/4)*(D2**2-D1**2)
        weld_area = [weld_area1,weld_area2,weld_area3]
        print('Need three layers of weld, ',np.round(string_height*1000,3),'mm each layer')
    else:
        string_height = soft_height/4
        layers = 4
        D = d+1*2*string_height
        weld_area1 = (pi/4)*(D**2-d**2)
        D1 = d+2*2*string_height
        weld_area2 = (pi/4)*(D1**2-D**2)
        D2 = d+3*2*string_height
        weld_area3 = (pi/4)*(D2**2-D1**2)        
        D3 = d+4*2*string_height
        weld_area4 = (pi/4)*(D3**2-D2**2)        
        weld_area = [weld_area1,weld_area2,weld_area3,weld_area4]
        print('Need four layers of weld, ',np.round(string_height*1000,3),'mm each layer')
    return layers,string_height,weld_area

def weld_strings(aksial_start,aksial_stop,weld_width):
    weld_length = aksial_start-aksial_stop
    strings = int(weld_length / weld_width)
    return strings

def grooveLogic(U,V,tj):
    weld_feed = 9.1 # 8-9.1 [m/min]
    max_weld_height = 0.005 # 5-6mm [m]
    rod_dia = 0.0012 # 1.2mm [m]
    rod_area = pi*(rod_dia*rod_dia)/4 # m^2
    weld_width = 0.007 # ca 7mm
    print ('U',U)
    print ('V',V)
    print ('tj',tj)
    
    if np.abs((V[0]+V[1])/2-(V[2]+V[3])/2)<=5 or V[3] == 1 or V[1] == 1 or V[2]-V[3] == 0:
        print('Pipe has only one groove')
#        V[1] = V[3]
        print('tool joint')
        [tjx1,tjy1,tjx2,tjy2]=tool_joint(canny_avg,U,tj,ign_u,W,H)
        cv2.waitKey() &0xFF
        cv2.destroyAllWindows()
        print('groove1')
        print(W)
        print(W[0])
        print(W[0][1])
        [g1x1,g1y1,g1x2,g1y2]=groove1(canny_avg,U[1],U[0],tj,50,tj,ign_u,W[0][1],W[0][0],H[0][0])
        cv2.waitKey() &0xFF
        cv2.destroyAllWindows()
        print('g1y1',g1y1,type(g1y1))
        [ws1_x,ws1_y,ws1_z] = transformation(U[0],V[0])
        [we1_x,we1_y,we1_z] = transformation(U[1],V[1])
        print('Start position for weld gun: ')
        print(' X: ',ws1_x*1000,'\n Y: ',ws1_y*1000,'\n Z: ',ws1_z*1000)
        print('End position for weld gun: ')
        print(' X: ',we1_x*1000,'\n Y: ',we1_y*1000,'\n Z: ',we1_z*1000)
        
        groove_dia = (g1y1[0]+g1y2[0])/2
        print('Machined groove pixel ',groove_dia)
        [g_x,g_y,g_z] = transformation(g1x1[0],groove_dia)
        print('Machined groove diameter: ',g_z*1000*2,'mm')
        tool_joint_dia = (tjy1[0]+tjy2[0])/2
        [tj_x,tj_y,tj_z] = transformation(tjx1[0],tool_joint_dia)
        print('Tool joint diameter: ',tj_z*1000*2,'mm')
        
        # weld program
        soft_height = tj_z-g_z
        print('soft-lagging height: ',np.round(soft_height*1000,3),'mm')

        layers,string_height,weld_area = layer(soft_height,max_weld_height,g_z)
        strings = weld_strings(ws1_y,we1_y,weld_width)
        print('Number of weld strings per layer: ',strings)
        weld_volume_pr_min = rod_area*weld_feed
        weld_volume_pr_rev = weld_area*weld_width    
        pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
        print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
        string_time = 60/pipe_rev
        print('time per string',np.round(string_time,1),'seconds')
        layer_time = string_time*strings
        print('time per layer',np.round(layer_time/60,1),'minutes')
        weld_time = layer_time*layers
        print('Total weld time',np.round(weld_time/60,1),'minutes')
        rod_used = weld_time/60*weld_feed
        print('Meters of wire used: ',np.round(rod_used,1))
        
    elif (V[0]+V[1]>V[2]+V[3]) and np.abs(U[1]-U[0])<np.abs(U[3]-U[2]):
        print('Pipe has two grooves')
        [tjx1,tjy1,tjx2,tjy2]=tool_joint(canny_avg,U,V[2],ign_u,W,H)
        cv2.waitKey() &0xFF
        cv2.destroyAllWindows()
        print('groove1')
        [g1x1,g1y1,g1x2,g1y2]=groove1(canny_avg,U[3],U[2],V,15,tj,ign_u,W[3],W[2],2*H[0])
        cv2.waitKey() &0xFF
        cv2.destroyAllWindows()
        print('g1y2',g1y2)
        print('groove2')
        [g2x1,g2y1,g2x2,g2y2]=groove2(canny_avg,U,V,g1y2[0],ign_u,W[3],W[2],H)
        cv2.waitKey() &0xFF
        cv2.destroyAllWindows()
        
        [ws2_x,ws2_y,ws2_z] = transformation(U[0],V[0])
        [we2_x,we2_y,we2_z] = transformation(U[1],V[1])
        print('First start position for weld gun: ')
        print(' X: ',ws2_x*1000,'\n Y: ',ws2_y*1000,'\n Z: ',ws2_z*1000)
        print('First end position for weld gun: ')
        print(' X: ',we2_x*1000,'\n Y: ',we2_y*1000,'\n Z: ',we2_z*1000)  
        
        [ws1_x,ws1_y,ws1_z] = transformation(U[2],V[2])
        [we1_x,we1_y,we1_z] = transformation(U[3],V[3])
        print('Last start position for weld gun: ')
        print(' X: ',ws1_x*1000,'\n Y: ',ws1_y*1000,'\n Z: ',ws1_z*1000)
        print('Last end position for weld gun: ')
        print(' X: ',we1_x*1000,'\n Y: ',we1_y*1000,'\n Z: ',we1_z*1000)

        groove_dia = (g1y1[0]+g1y2[0])/2
        [g_x,g_y,g_z] = transformation(g1x1[0],groove_dia)
        
        groove_dia2 = (g2y1[0]+g2y2[0])/2
        [g_x,g_y,g_z2] = transformation(g2x1[0],groove_dia2)
        
        tool_joint_dia = (tjy1[0]+tjy2[0])/2
        [tj_x,tj_y,tj_z] = transformation(tjx1[0],tool_joint_dia)
        print('Tool joint diameter: ',tj_z*1000*2,'mm')        
        print('Machined groove diameter highest diameter: ',g_z*1000*2,'mm')
        print('Machined groove diameter lowest diameter: ',g_z2*1000*2,'mm')
        
        # weld program
        print('-_-_-_-_-_-_-_-_'*3)
        print('Welding programme:')
        print('-_-_-_-_-_-_-_-_'*3)
        # lowest diameter groove:
        
        soft_height = g_z-g_z2
        print('soft-lagging height: ',np.round(soft_height*1000,3),'mm')

        layers,string_height,weld_area = layer(soft_height,max_weld_height,g_z2)
        strings = weld_strings(ws2_y,we2_y,weld_width)
        print('Number of weld strings smaller groove: ',strings)
        weld_volume_pr_min = rod_area*weld_feed
        
        if layers == 1:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            weld_time1 = string_time*strings
            print('time for first groove',np.round(weld_time1/60,1),'minutes')
        elif layers == 2:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time1 = string_time*strings
            print('time first layer',np.round(layer_time1/60,1),'minutes')
            
            weld_volume_pr_rev = weld_area[1]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time2 = string_time*strings
            print('time first groove',np.round(layer_time2/60,1),'minutes')
            weld_time1 = layer_time1 + layer_time2
        elif layers == 3:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time1 = string_time*strings
            print('time first layer',np.round(layer_time1/60,1),'minutes')
            
            weld_volume_pr_rev = weld_area[1]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time2 = string_time*strings
            print('time second layer',np.round(layer_time2/60,1),'minutes')        
        
            weld_volume_pr_rev = weld_area[2]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            print('time per string',np.round(string_time,1),'seconds')
            layer_time3 = string_time*strings
            print('time third layer',np.round(layer_time3/60,1),'minutes')     
            weld_time1 = layer_time1+layer_time2+layer_time3   
        
        # Larger diameter groove

        soft_height = tj_z-g_z
        print('soft-lagging height: ',np.round(soft_height*1000,3),'mm')

        layers,string_height,weld_area = layer(soft_height,max_weld_height,g_z)
        strings = weld_strings(ws1_y,we1_y,weld_width)
        print('Number of weld strings larger groove: ',strings)
        weld_volume_pr_min = rod_area*weld_feed
        
        if layers == 1:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            weld_time2 = string_time*strings
            print('time second groove',np.round(weld_time2/60,1),'minutes')
        elif layers == 2:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time1 = string_time*strings
            print('time first layer',np.round(layer_time1/60,1),'minutes')
            
            weld_volume_pr_rev = weld_area[1]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time2 = string_time*strings
            print('time second layer',np.round(layer_time2/60,1),'minutes')
            weld_time2 = layer_time1 + layer_time2
        elif layers == 3:
            weld_volume_pr_rev = weld_area[0]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time1 = string_time*strings
            print('time first layer',np.round(layer_time1/60,1),'minutes')
            
            weld_volume_pr_rev = weld_area[1]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            layer_time2 = string_time*strings
            print('time second layer',np.round(layer_time2/60,1),'minutes')        
        
            weld_volume_pr_rev = weld_area[2]*weld_width    
            pipe_rev = weld_volume_pr_min/weld_volume_pr_rev # rev/min
            print('Pipe rotational speed: ',np.round(pipe_rev,3),'rev/min')
            string_time = 60/pipe_rev
            print('time per string',np.round(string_time,1),'seconds')
            layer_time3 = string_time*strings
            print('time third layer',np.round(layer_time3/60,1),'minutes')     
            weld_time2 = layer_time1+layer_time2+layer_time3
        weld_time = weld_time1+weld_time2
        print('Total weld time',np.round(weld_time/60,1),'minutes')
        rod_used = weld_time/60*weld_feed
        print('Meters of wire used: ',np.round(rod_used,1))
       
    else:
        print('Kristoffer is confused')

grooveLogic(U,V,tj)

print('--- %s seconds ---' % np.round((time.time()- start_time),2))



